
Redmine - Defect #19485

Column 'address' in where clause may be ambiguous

2015-03-25 21:07 - Andrey Sennikov

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 3.0.4   

Resolution: Fixed Affected version: 3.0.1

Description

Hello.

i`ve got the following error after upgrading from 2.6.1 to 3.0.1

Mysql2::Error: Column 'address' in where clause is ambiguous:

 SELECT  DISTINCT `users`.* FROM `users` INNER JOIN `email_addresses` ON `email_addresses`.`user_i

d` = `users`.`id` WHERE `users`.`type` 

 IN ('User', 'AnonymousUser') AND (LOWER(address) IN ('myemail@mail.com'))  ORDER BY `users`.`id` 

ASC LIMIT 1

 emails received by cronjob every minute.

rake redmine:email:receive_imap RAILS_ENV="production" host=imap.gmail.com port=993 username=email@email

password=password ssl=true move_on_success=read project=public-project247 category=HelpDesk unknown_user=create

no_permission_check=1 allow_override=tracker,priority,project,status,category,assigned_to

Please give advise for solving this issue

Environment:

Redmine version                3.0.1.stable

Ruby version                   1.9.3-p194 (2012-04-20) [x86_64-linux]

Rails version                  4.2.0

Environment                    production

Database adapter               Mysql2

SCM:

Git                            1.7.10.4

Filesystem

Redmine plugins:

redmine_agile                  1.3.8

redmine_email_fetcher          0.3.0

redmine_issue_history          1.0.0

redmine_wysiwyg                1.0.0

plugins

Redmine Agile plugin (Light version)

redmine_issue_history

redmine_wysiwyg

Related issues:

Has duplicate Redmine - Defect #19595: Broken "receiving emails" Closed

Has duplicate Redmine - Defect #19884: address column in WHERE clause is ambi... Closed

Associated revisions

Revision 14284 - 2015-05-30 10:23 - Jean-Philippe Lang

Column 'address' in where clause may be ambiguous (#19485).

Revision 14285 - 2015-05-30 10:24 - Jean-Philippe Lang

Merged r14284 (#19485).

History
#1 - 2015-03-25 21:34 - Toshi MARUYAMA

- Description updated

#2 - 2015-04-08 09:59 - Rafał Lisowski

are you sure that you don't have any other plugins?

In my logs sql look the same and is working:

SELECT  DISTINCT `users`.* FROM `users` 

  INNER JOIN `email_addresses` ON `email_addresses`.`user_id` = `users`.`id` 

  WHERE `users`.`type` IN ('User', 'AnonymousUser') AND (LOWER(address) IN ('l.ka@company.com'))  

  ORDER BY `users`.`id` ASC LIMIT 1

#3 - 2015-04-08 10:32 - Toshi MARUYAMA

- Status changed from New to Needs feedback

I think your "users" table has "address" column created by plugin which you use or used.

#4 - 2015-04-12 06:38 - Go MAEDA

The same error is reported in #19595 and that issue has a workaround.

#5 - 2015-04-12 06:40 - Toshi MARUYAMA

- Has duplicate Defect #19595: Broken "receiving emails" added

#6 - 2015-04-12 07:02 - Go MAEDA

A workaround by Andrey Sennikov (#19595).

Index: app/models/user.rb

===================================================================

--- app/models/user.rb    (revision 14160)

+++ app/models/user.rb    (working copy)

@@ -130,7 +130,7 @@

   scope :having_mail, lambda {|arg|

     addresses = Array.wrap(arg).map {|a| a.to_s.downcase}

     if addresses.any?

-      joins(:email_addresses).where("LOWER(address) IN (?)", addresses).uniq

+      joins(:email_addresses).where("LOWER(email_addresses.address) IN (?)", addresses).uniq

     else

       none

     end

#7 - 2015-05-20 05:04 - Toshi MARUYAMA

- Subject changed from error in imap fetch task after update to 3.0.1 to Column 'address' in where clause is ambiguous

#8 - 2015-05-20 05:06 - Toshi MARUYAMA

- Has duplicate Defect #19884: address column in WHERE clause is ambiguous added

#9 - 2015-05-20 05:06 - Toshi MARUYAMA

- Category changed from Email receiving to Database

#10 - 2015-05-24 20:10 - Future Link Corporation pkgsrc team

For us, it was the People plugin which caused this problem. In any case, less ambiguity in the SELECT statement wouldn't be a bad thing. Can this

patch be integrated? It seems we fixed it in the same way.

#11 - 2015-05-25 13:16 - Jean-Philippe Lang

- Target version set to 3.0.4

#12 - 2015-05-30 10:24 - Jean-Philippe Lang

- Subject changed from Column 'address' in where clause is ambiguous to Column 'address' in where clause may be ambiguous

- Category changed from Database to Code cleanup/refactoring

- Status changed from Needs feedback to Closed
https://www.redmine.org/issues/19595
https://www.redmine.org/issues/19595
http://www.redminecrm.com/projects/people/pages/1


- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fixed in r14284.
